Bug 1475327 (CVE-2017-11499) - CVE-2017-11499 nodejs: Constant Hashtable Seeds vulnerability
Summary: CVE-2017-11499 nodejs: Constant Hashtable Seeds vulnerability
Keywords:
Status: CLOSED ERRATA
Alias: CVE-2017-11499
Product: Security Response
Classification: Other
Component: vulnerability
Version: unspecified
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Red Hat Product Security
QA Contact:
URL:
Whiteboard:
Depends On: 1475328 1475329 1475330 1475613 1476314 1476315 1476316 1476317
Blocks: 1475332
TreeView+ depends on / blocked
 
Reported: 2017-07-26 12:51 UTC by Adam Mariš
Modified: 2019-09-29 14:17 UTC (History)
39 users (show)

Fixed In Version: nodejs 4.8.4, nodejs 6.11.1, nodejs 7.10.1, nodejs 8.1.4
Doc Type: If docs needed, set a value
Doc Text:
It was found that Node.js was using a non-randomized seed when populating hash tables. An attacker, able to supply a large number of inputs, could send specially crafted entries to the Node.js application, maximizing hash collisions to trigger an excessive amount of CPU usage, resulting in a denial of service.
Clone Of:
Environment:
Last Closed: 2017-10-23 15:22:05 UTC


Attachments (Terms of Use)


Links
System ID Priority Status Summary Last Updated
Red Hat Product Errata RHSA-2017:2908 normal SHIPPED_LIVE Moderate: rh-nodejs6-nodejs security update 2017-10-18 11:51:08 UTC
Red Hat Product Errata RHSA-2017:3002 normal SHIPPED_LIVE Moderate: rh-nodejs4-nodejs security and bug fix update 2017-10-23 13:19:08 UTC

Description Adam Mariš 2017-07-26 12:51:34 UTC
Node.js v4.0 through v4.8.3, all versions of v5.x, v6.0 through v6.11.0, v7.0 through v7.10.0, and v8.0 through v8.1.3 was susceptible to hash flooding remote DoS attacks as the HashTable seed was constant across a given released version of Node.js. This was a result of building with V8 snapshots enabled by default which caused the initially randomized seed to be overwritten on startup.

External References:

https://nodejs.org/en/blog/vulnerability/july-2017-security-releases/

Comment 1 Adam Mariš 2017-07-26 12:52:26 UTC
Created nodejs tracking bugs for this issue:

Affects: epel-all [bug 1475330]
Affects: fedora-all [bug 1475328]
Affects: openshift-1 [bug 1475329]

Comment 3 Cedric Buissart 🐶 2017-07-28 09:45:48 UTC
Lowering severity to Medium to keep it aligned with similar remote DoS by hash table issues.

Comment 9 Cedric Buissart 🐶 2017-08-01 13:24:36 UTC
The upstream fix pointed in the upstream release note (commit 51d69d2bec) was a temporary fix only, aimed at disabling snapshot by default, and had a negative performance impact during creation of contexts (e.g.: vm.runInNewContext() calls).

A later patch re-enables snapshot by default, and adds re-hashing after de-serialization as mitigation : https://github.com/nodejs/node/commit/8dce05fa

Comment 10 errata-xmlrpc 2017-10-18 07:51:45 UTC
This issue has been addressed in the following products:

  Red Hat Software Collections for Red Hat Enterprise Linux 6
  Red Hat Software Collections for Red Hat Enterprise Linux 6.7 EUS
  Red Hat Software Collections for Red Hat Enterprise Linux 7
  Red Hat Software Collections for Red Hat Enterprise Linux 7.3 EUS

Via RHSA-2017:2908 https://access.redhat.com/errata/RHSA-2017:2908

Comment 11 errata-xmlrpc 2017-10-23 09:20:14 UTC
This issue has been addressed in the following products:

  Red Hat Software Collections for Red Hat Enterprise Linux 6
  Red Hat Software Collections for Red Hat Enterprise Linux 6.7 EUS
  Red Hat Software Collections for Red Hat Enterprise Linux 7
  Red Hat Software Collections for Red Hat Enterprise Linux 7.3 EUS

Via RHSA-2017:3002 https://access.redhat.com/errata/RHSA-2017:3002

Comment 12 Jason Shepherd 2018-04-03 06:23:41 UTC
Openshift Enterprise uses latest RHSCL nodejs-4-rhel7 image which contains a fix for this issue. Marking Openshift Enterprise as not affected.

https://github.com/openshift/library/blob/4e6ba65846f803063b1d977eaa57c89af440812f/official/nodejs/imagestreams/nodejs-rhel7.json#L64

Comment 13 Jason Shepherd 2018-04-03 06:31:54 UTC
Marking Openshift Online as not affected for the same reasons as comment 12.


Note You need to log in before you can comment on or make changes to this bug.